/*
// author : Sven Goethel - Stapenhorststrasse 35a - 33615 Bielefeld
*/
#include "interror.h"
#ifdef _C166_
  #include <termdac1.h>
  #include "SYMBDAC1.H"
  extern void cputs(char*);
  extern fehler(void * icon, char *text);
#endif
void int_err ( int line , const char * file )
{
  #ifdef _C166_
	  char text [ 100 ], text2[100];
  #else
		char text [ 500 ];
	#endif
	char c;
	int i, a, b;

	#ifdef _C166_
		/* ONLY THE FILENAME WITHOUT SUFFIX TO SAVE TEXTBUFFER */
		/* ERROR -> CPU-WITH-TERMINAL AND STOP ! */
		for(i=strlen(file)-1, a=0, b=strlen(file); 
				i>0 && file[i]!=0 && file[i]!='/' && file[i]!='\\';
				i--
			 ) 
    {
		  if(b==strlen(file) && file[i]=='.') b=i;
    }
		if(file[i]=='/'||file[i]=='\\') a=i+1;

    #ifdef M_CPU
			strcpy ( text , "MASCH: ");
    #else
			strcpy ( text , "BEDIN: ");
		#endif
		strncat ( text, &(file[a]), b-a );
		sprintf ( text2 , ", %d" , line ) ;
		strcat  ( text, text2);
		fehler(FEHLER_SYMBOL, text);
		while(1) ;
  #else
	  sprintf ( text , "Intern Error in %s, line %d.\nPlease contact the software-developer !\n" , file , line ) ;
   	printf("%s\n", text);
	  exit(1);
	#endif
}

void ErrorOut(const char *fmt, ...)
{
  char Buffer[500], c;
	va_list va;
	va_start(va, fmt);

	(void) vsprintf(Buffer, fmt, va);

  #ifdef _C166_
	  clrscr();
	  while(kbhit()) getch();
    cputs("\n\r");
    #ifdef M_CPU
			cputs ( "MASCH: \n\r======\n\r");
    #else
			cputs ( "BEDIN: \n\r======\n\r");
		#endif
	  cputs(Buffer);
    cputs("\n\r\n\r<PLEASE PRESS ANY KEY>\n\r");
    while(!kbhit()) ;
		getch();
  #else
		fprintf(stderr,"%s\n", Buffer);
  #endif

	va_end(va);
}

