/*************************************************************************/
/*
 *  Datei           : strclass.c
 *  Inhalt          : Definition fuer Funktionen der Klasse :
 *                        o StrClass
 *  Programmierer   : Sven Goethel
 *                      Stapenhorststr.35a
 *                      33615 Bielefeld
 *                      0521/139228
 *  Erstellungsdatum: 05.05.1994
 *  nderungsdatum  : 16.10.1994
 *  Projekt         : ...
 *  Verzeichnis     :
 *  Dokumentation   : ...
 *
 *    PUBLIC DOMAIN ....
 *
 *  $Log: strclass.cc $
 *  Revision 1.4  1995/04/07 16:54:57  Sven_Goethel_DFP
 *  *** empty log message ***
 *  Revision 1.3  1995/04/04 10:37:36  Sven_Goethel
 *  *** empty log message ***
 *  Revision 1.2  1994/12/15 15:28:28  Sven_Goethel
 *  the very first check in !!!
 *  all files contains the log message now !!!
 *  Sven Goethel, Bielefeld 14.12.1994 !!!
 *
 *  Revision 1.1  1994/12/15 15:18:45  Sven_Goethel
 *  Initial revision
 *
 */
/*************************************************************************/

# include "strclass.h"

static rtti * RttiStrClass=NULL;

static void StrClassReset(void)
{
  RttiStrClass=NULL;
}

const rtti * const GetRttiStrClass(void)
{ if(RttiStrClass==NULL) INT_ERR(__LINE__); return RttiStrClass; }

const rtti * const StrClassRegisterRtti       (void)
{
  if(RttiStrClass == NULL)
  {
    RttiStrClass = NewRttiType(sizeof(StrClass));
    RegisterRttiFct(RttiStrClass,
                    (T_FCmpRtti) CmpStrClass,
                    (T_FCreateRtti) CreateStrClass,
                    (T_FCopyCreateRtti) CopyCreateStrClass,
                    (T_FDestroyRtti) DestroyStrClass,
                    (T_FResetRtti) StrClassReset
                   );
  }
  return GetRttiStrClass();
}

int  CmpStrClass                 ( const StrClass *a , const StrClass *b)
{
  if(a==NULL) INT_ERR(__LINE__);
  if(b==NULL) INT_ERR(__LINE__);
  return strcmp(a->StrPtr, b->StrPtr)==0;
}

rtti  * CreateStrClass        ( void )
{
  StrClass *res=(StrClass *)calloc(1, sizeof(StrClass));
  if(res==NULL) INT_ERR(__LINE__);
  res->rtype.type=RttiStrClass->type;
  res->rtype.sz=RttiStrClass->sz;
  return C_RTTI(res);
}

static void CopyStrClass    ( StrClass *res, const char *a )
{
  if(res==NULL) INT_ERR(__LINE__);
  if(a!=NULL)
  {
    if ( ( res->StrPtr=calloc(1, strlen(a)+1) ) == NULL )
    {
      ErrorOut("\n Speicherfehler.");
      ErrorOut("\n Es wurde versucht ein StringClass-Element fuer einen String");
      ErrorOut("\n mit der Laenge : %d zu erzeugen.\n", strlen(a));
      INT_ERR(__LINE__);
    }
    strcpy(res->StrPtr, a);
  } else res->StrPtr=NULL;
}

StrClass * CCopyCreateStrClass   ( const char * StrPtr)
{
  StrClass *res=(StrClass *)(CreateStrClass());
  CopyStrClass(res, StrPtr);
  return res;
}

rtti * CopyCreateStrClass    ( const StrClass *a )
{
  if(a==NULL) INT_ERR(__LINE__);
  return C_RTTI(CCopyCreateStrClass(a->StrPtr));
}

void       DestroyStrClass       ( StrClass *a )
{
  if(a==NULL) INT_ERR(__LINE__);
  if(a->StrPtr!=NULL) free(a->StrPtr);
  free(a);
}

int        LengthStrClass        ( const StrClass *a )
{
  if(a==NULL) INT_ERR(__LINE__);
  if(a->StrPtr!=NULL) return strlen(a->StrPtr);
  return 0;
}

char     * GetStrPtr             ( const StrClass *a )
{
  if(a==NULL) INT_ERR(__LINE__);
  return a->StrPtr;
}

void CatStrClass(StrClass *a, const StrClass *m)
{
  if(a==NULL) INT_ERR(__LINE__);
  if(m==NULL) INT_ERR(__LINE__);
  CCatStrClass(a, m->StrPtr);
}

void CCatStrClass(StrClass *a, const char *StrPtr)
{
   char *Buffer=NULL;
   unsigned int BufferLength=1;

   if(a==NULL) INT_ERR(__LINE__);
   if(StrPtr==NULL) return;

   if(a->StrPtr)
     BufferLength+=strlen(a->StrPtr);

   if(StrPtr)
     BufferLength+=strlen(StrPtr);
   else INT_ERR(__LINE__);

   if ( ( Buffer=calloc(1, BufferLength) ) == NULL ) INT_ERR(__LINE__);
   if(a->StrPtr)
     strcpy(Buffer, a->StrPtr);
   else Buffer[0]=0;
   strcat(Buffer, StrPtr);
   if(a->StrPtr) { free(a->StrPtr); a->StrPtr=NULL; }
   CopyStrClass(a, Buffer);
   free(Buffer);
}

void  CPutStrClass           (StrClass *a, const char *StrPtr)
{
  if(a==NULL) INT_ERR(__LINE__);
  if(StrPtr==NULL) INT_ERR(__LINE__);
  if(a->StrPtr)
  {
    free(a->StrPtr);
    a->StrPtr=NULL;
  }
  CopyStrClass(a, StrPtr);
}

void       StrClassPrintf        (StrClass *a, const char *fmt, ...)
{
  va_list va;
  char Buffer[2000];

  if(a==NULL) INT_ERR(__LINE__);

  va_start(va, fmt);
  (void) vsprintf(Buffer, fmt, va);
  va_end(va);

  if(a->StrPtr)
  {
    free(a->StrPtr);
    a->StrPtr=NULL;
  }
  CopyStrClass(a, Buffer);
}
