// ComClass.h  this is the header for the ComClass-class
// which should support the summasketch tablet on a serial port

#ifndef _COMCLASS_H
#define _COMCLASS_H

# include <windows.h>
#include "bool.h"

class ComClass
{
  public:
		ComClass(int port_num, int baud, char parity,
						 int bits, bool hardflow, bool binary,
						 double stopbits, double TimeOut
            )
		: ok(1), errno(0), TimeOut_secs(TimeOut), TimeOut_Flag(0)
    { OpenPort(port_num, baud, parity, bits, hardflow, binary, stopbits); }
      
    virtual ~ComClass() { ClosePort(); }    
    
		void OpenPort(int port_num, int baud, char parity,
									int bits, bool hardflow, bool binary,
									double stopbits
                 );
		void ClosePort();
		void PutChar(char c);
		void Clear() { ok=1; TimeOut_Flag=0; errno=0; };
    char GetChar();
  
    int           isok()    { return ok; }
    int           isTimeOut() { return TimeOut_Flag; }
    int           geterr()  { return errno; }
    COMSTAT       getcmst() { return cmst; }
    
  private:
    COMSTAT cmst;
    int  idComDev;
    int ok;
    int TimeOut_Flag;
    double TimeOut_secs;
    int errno;           
};

#endif
